<!DOCTYPE html><html lang="en"><head><meta charset="utf-8"><meta name="viewport" content="width=device-width, initial-scale=1.0"><meta name="generator" content="rustdoc"><meta name="description" content="Source of the Rust file `crates&#x2F;framework&#x2F;dyndl&#x2F;realize&#x2F;src&#x2F;lib.rs`."><meta name="keywords" content="rust, rustlang, rust-lang"><title>lib.rs - source</title><link rel="stylesheet" type="text/css" href="../../normalize.css"><link rel="stylesheet" type="text/css" href="../../rustdoc.css" id="mainThemeStyle"><link rel="stylesheet" type="text/css" href="../../light.css"  id="themeStyle"><link rel="stylesheet" type="text/css" href="../../dark.css" disabled ><link rel="stylesheet" type="text/css" href="../../ayu.css" disabled ><script id="default-settings" ></script><script src="../../storage.js"></script><script src="../../crates.js"></script><noscript><link rel="stylesheet" href="../../noscript.css"></noscript><link rel="alternate icon" type="image/png" href="../../favicon-16x16.png"><link rel="alternate icon" type="image/png" href="../../favicon-32x32.png"><link rel="icon" type="image/svg+xml" href="../../favicon.svg"><style type="text/css">#crate-search{background-image:url("../../down-arrow.svg");}</style></head><body class="rustdoc source"><!--[if lte IE 11]><div class="warning">This old browser is unsupported and will most likely display funky things.</div><![endif]--><nav class="sidebar"><div class="sidebar-menu" role="button">&#9776;</div><a href='../../dyndl_realize/index.html'><div class='logo-container rust-logo'><img src='../../rust-logo.png' alt='logo'></div></a></nav><div class="theme-picker"><button id="theme-picker" aria-label="Pick another theme!" aria-haspopup="menu" title="themes"><img width="18" height="18" alt="Pick another theme!" src="../../brush.svg"></button><div id="theme-choices" role="menu"></div></div><nav class="sub"><form class="search-form"><div class="search-container"><div><select id="crate-search"><option value="All crates">All crates</option></select><input class="search-input" name="search" disabled autocomplete="off" spellcheck="false" placeholder="Click or press ‘S’ to search, ‘?’ for more options…" type="search"></div><button type="button" id="help-button" title="help">?</button><a id="settings-menu" href="../../settings.html" title="settings"><img width="18" height="18" alt="Change settings" src="../../wheel.svg"></a></div></form></nav><section id="main" class="content"><div class="example-wrap"><pre class="line-numbers"><span id="1">  1</span>
<span id="2">  2</span>
<span id="3">  3</span>
<span id="4">  4</span>
<span id="5">  5</span>
<span id="6">  6</span>
<span id="7">  7</span>
<span id="8">  8</span>
<span id="9">  9</span>
<span id="10"> 10</span>
<span id="11"> 11</span>
<span id="12"> 12</span>
<span id="13"> 13</span>
<span id="14"> 14</span>
<span id="15"> 15</span>
<span id="16"> 16</span>
<span id="17"> 17</span>
<span id="18"> 18</span>
<span id="19"> 19</span>
<span id="20"> 20</span>
<span id="21"> 21</span>
<span id="22"> 22</span>
<span id="23"> 23</span>
<span id="24"> 24</span>
<span id="25"> 25</span>
<span id="26"> 26</span>
<span id="27"> 27</span>
<span id="28"> 28</span>
<span id="29"> 29</span>
<span id="30"> 30</span>
<span id="31"> 31</span>
<span id="32"> 32</span>
<span id="33"> 33</span>
<span id="34"> 34</span>
<span id="35"> 35</span>
<span id="36"> 36</span>
<span id="37"> 37</span>
<span id="38"> 38</span>
<span id="39"> 39</span>
<span id="40"> 40</span>
<span id="41"> 41</span>
<span id="42"> 42</span>
<span id="43"> 43</span>
<span id="44"> 44</span>
<span id="45"> 45</span>
<span id="46"> 46</span>
<span id="47"> 47</span>
<span id="48"> 48</span>
<span id="49"> 49</span>
<span id="50"> 50</span>
<span id="51"> 51</span>
<span id="52"> 52</span>
<span id="53"> 53</span>
<span id="54"> 54</span>
<span id="55"> 55</span>
<span id="56"> 56</span>
<span id="57"> 57</span>
<span id="58"> 58</span>
<span id="59"> 59</span>
<span id="60"> 60</span>
<span id="61"> 61</span>
<span id="62"> 62</span>
<span id="63"> 63</span>
<span id="64"> 64</span>
<span id="65"> 65</span>
<span id="66"> 66</span>
<span id="67"> 67</span>
<span id="68"> 68</span>
<span id="69"> 69</span>
<span id="70"> 70</span>
<span id="71"> 71</span>
<span id="72"> 72</span>
<span id="73"> 73</span>
<span id="74"> 74</span>
<span id="75"> 75</span>
<span id="76"> 76</span>
<span id="77"> 77</span>
<span id="78"> 78</span>
<span id="79"> 79</span>
<span id="80"> 80</span>
<span id="81"> 81</span>
<span id="82"> 82</span>
<span id="83"> 83</span>
<span id="84"> 84</span>
<span id="85"> 85</span>
<span id="86"> 86</span>
<span id="87"> 87</span>
<span id="88"> 88</span>
<span id="89"> 89</span>
<span id="90"> 90</span>
<span id="91"> 91</span>
<span id="92"> 92</span>
<span id="93"> 93</span>
<span id="94"> 94</span>
<span id="95"> 95</span>
<span id="96"> 96</span>
<span id="97"> 97</span>
<span id="98"> 98</span>
<span id="99"> 99</span>
<span id="100">100</span>
<span id="101">101</span>
<span id="102">102</span>
<span id="103">103</span>
<span id="104">104</span>
<span id="105">105</span>
<span id="106">106</span>
<span id="107">107</span>
<span id="108">108</span>
<span id="109">109</span>
<span id="110">110</span>
<span id="111">111</span>
<span id="112">112</span>
<span id="113">113</span>
<span id="114">114</span>
<span id="115">115</span>
<span id="116">116</span>
<span id="117">117</span>
<span id="118">118</span>
<span id="119">119</span>
<span id="120">120</span>
<span id="121">121</span>
<span id="122">122</span>
<span id="123">123</span>
<span id="124">124</span>
<span id="125">125</span>
<span id="126">126</span>
<span id="127">127</span>
<span id="128">128</span>
<span id="129">129</span>
<span id="130">130</span>
<span id="131">131</span>
<span id="132">132</span>
<span id="133">133</span>
<span id="134">134</span>
<span id="135">135</span>
<span id="136">136</span>
<span id="137">137</span>
<span id="138">138</span>
<span id="139">139</span>
<span id="140">140</span>
<span id="141">141</span>
<span id="142">142</span>
<span id="143">143</span>
<span id="144">144</span>
<span id="145">145</span>
<span id="146">146</span>
<span id="147">147</span>
<span id="148">148</span>
<span id="149">149</span>
<span id="150">150</span>
<span id="151">151</span>
<span id="152">152</span>
<span id="153">153</span>
<span id="154">154</span>
<span id="155">155</span>
<span id="156">156</span>
<span id="157">157</span>
<span id="158">158</span>
<span id="159">159</span>
<span id="160">160</span>
<span id="161">161</span>
<span id="162">162</span>
<span id="163">163</span>
<span id="164">164</span>
<span id="165">165</span>
<span id="166">166</span>
<span id="167">167</span>
<span id="168">168</span>
<span id="169">169</span>
<span id="170">170</span>
<span id="171">171</span>
<span id="172">172</span>
<span id="173">173</span>
<span id="174">174</span>
<span id="175">175</span>
<span id="176">176</span>
<span id="177">177</span>
<span id="178">178</span>
<span id="179">179</span>
<span id="180">180</span>
<span id="181">181</span>
<span id="182">182</span>
<span id="183">183</span>
<span id="184">184</span>
<span id="185">185</span>
<span id="186">186</span>
<span id="187">187</span>
<span id="188">188</span>
<span id="189">189</span>
<span id="190">190</span>
<span id="191">191</span>
<span id="192">192</span>
<span id="193">193</span>
<span id="194">194</span>
<span id="195">195</span>
<span id="196">196</span>
<span id="197">197</span>
<span id="198">198</span>
<span id="199">199</span>
<span id="200">200</span>
<span id="201">201</span>
<span id="202">202</span>
<span id="203">203</span>
<span id="204">204</span>
<span id="205">205</span>
<span id="206">206</span>
<span id="207">207</span>
<span id="208">208</span>
<span id="209">209</span>
<span id="210">210</span>
<span id="211">211</span>
<span id="212">212</span>
<span id="213">213</span>
<span id="214">214</span>
<span id="215">215</span>
<span id="216">216</span>
<span id="217">217</span>
<span id="218">218</span>
<span id="219">219</span>
<span id="220">220</span>
<span id="221">221</span>
<span id="222">222</span>
<span id="223">223</span>
<span id="224">224</span>
<span id="225">225</span>
<span id="226">226</span>
<span id="227">227</span>
<span id="228">228</span>
<span id="229">229</span>
<span id="230">230</span>
<span id="231">231</span>
<span id="232">232</span>
<span id="233">233</span>
<span id="234">234</span>
<span id="235">235</span>
<span id="236">236</span>
<span id="237">237</span>
<span id="238">238</span>
<span id="239">239</span>
<span id="240">240</span>
<span id="241">241</span>
<span id="242">242</span>
<span id="243">243</span>
<span id="244">244</span>
<span id="245">245</span>
<span id="246">246</span>
<span id="247">247</span>
<span id="248">248</span>
<span id="249">249</span>
<span id="250">250</span>
<span id="251">251</span>
<span id="252">252</span>
<span id="253">253</span>
<span id="254">254</span>
<span id="255">255</span>
<span id="256">256</span>
<span id="257">257</span>
<span id="258">258</span>
<span id="259">259</span>
<span id="260">260</span>
<span id="261">261</span>
<span id="262">262</span>
<span id="263">263</span>
</pre><pre class="rust"><code><span class="attribute">#![<span class="ident">no_std</span>]</span>
<span class="attribute">#![<span class="ident">feature</span>(<span class="ident">alloc_prelude</span>)]</span>

<span class="attribute">#[<span class="ident">macro_use</span>]</span>
<span class="kw">extern</span> <span class="kw">crate</span> <span class="ident">alloc</span>;

<span class="kw">use</span> <span class="ident">alloc::collections::btree_map::BTreeMap</span>;

<span class="kw">use</span> <span class="ident">dyndl_types</span>::<span class="kw-2">*</span>;
<span class="kw">use</span> <span class="ident">icecap_core::prelude</span>::<span class="kw-2">*</span>;

<span class="kw">mod</span> <span class="ident">cregion</span>;
<span class="kw">mod</span> <span class="ident">allocator</span>;
<span class="kw">mod</span> <span class="ident">utils</span>;
<span class="kw">mod</span> <span class="ident">model_view</span>;
<span class="kw">mod</span> <span class="ident">initialize_subsystem_objects</span>;

<span class="kw">use</span> <span class="ident">model_view::ModelView</span>;
<span class="kw">use</span> <span class="ident">utils</span>::{<span class="ident">blueprint_of</span>, <span class="ident">size_bits_to_contain</span>};

<span class="kw">pub</span> <span class="kw">use</span> <span class="ident">allocator</span>::{<span class="ident">Allocator</span>, <span class="ident">AllocatorBuilder</span>};
<span class="kw">pub</span> <span class="kw">use</span> <span class="ident">cregion</span>::{<span class="ident">CRegion</span>, <span class="ident">Slot</span>};
<span class="kw">pub</span> <span class="kw">use</span> <span class="ident">initialize_subsystem_objects::SubsystemObjectInitializationResources</span>;

<span class="doccomment">/// Unique id for an untyped block of memory</span>
<span class="attribute">#[<span class="ident">derive</span>(<span class="ident">Clone</span>, <span class="ident">Debug</span>)]</span>
<span class="kw">pub</span> <span class="kw">struct</span> <span class="ident">UntypedId</span> {
    <span class="doccomment">/// The physical address of the untyped block</span>
    <span class="kw">pub</span> <span class="ident">paddr</span>: <span class="ident">usize</span>,

    <span class="doccomment">/// log_2 of the size (in bytes) of the untyped block</span>
    <span class="doccomment">/// (e.g., for a 32 byte block, `size_bits` is 5)</span>
    <span class="kw">pub</span> <span class="ident">size_bits</span>: <span class="ident">usize</span>,
}

<span class="kw">pub</span> <span class="kw">struct</span> <span class="ident">ElaboratedUntyped</span> {
    <span class="kw">pub</span> <span class="ident">cptr</span>: <span class="ident">Untyped</span>,
    <span class="kw">pub</span> <span class="ident">untyped_id</span>: <span class="ident">UntypedId</span>,
}

<span class="kw">pub</span> <span class="kw">type</span> <span class="ident">Externs</span> <span class="op">=</span> <span class="ident">BTreeMap</span><span class="op">&lt;</span><span class="ident">String</span>, <span class="ident">Extern</span><span class="op">&gt;</span>;

<span class="kw">pub</span> <span class="kw">struct</span> <span class="ident">Extern</span> {
    <span class="kw">pub</span> <span class="ident">ty</span>: <span class="ident">ExternObj</span>,
    <span class="kw">pub</span> <span class="ident">cptr</span>: <span class="ident">Unspecified</span>,
}

<span class="kw">pub</span> <span class="kw">struct</span> <span class="ident">Realizer</span> {
    <span class="kw">pub</span> <span class="ident">initialization_resources</span>: <span class="ident">SubsystemObjectInitializationResources</span>,
    <span class="kw">pub</span> <span class="ident">allocator</span>: <span class="ident">Allocator</span>,
    <span class="kw">pub</span> <span class="ident">externs</span>: <span class="ident">Externs</span>,
}

<span class="kw">pub</span> <span class="kw">struct</span> <span class="ident">Subsystem</span> {
    <span class="kw">pub</span> <span class="ident">virtual_cores</span>: <span class="ident">Vec</span><span class="op">&lt;</span><span class="ident">VirtualCore</span><span class="op">&gt;</span>,

    <span class="comment">// ID of the Untyped retyped for the realm&#39;s CNode.</span>
    <span class="kw">pub</span> <span class="ident">cnode_untyped_id</span>: <span class="ident">UntypedId</span>,

    <span class="comment">// IDs of the Untypeds retyped for the realm&#39;s objects.</span>
    <span class="kw">pub</span> <span class="ident">object_untyped_ids</span>: <span class="ident">Vec</span><span class="op">&lt;</span><span class="ident">UntypedId</span><span class="op">&gt;</span>,

    <span class="kw">pub</span> <span class="ident">externs</span>: <span class="ident">Externs</span>,
}

<span class="kw">pub</span> <span class="kw">type</span> <span class="ident">VirtualCores</span> <span class="op">=</span> <span class="ident">Vec</span><span class="op">&lt;</span><span class="ident">VirtualCore</span><span class="op">&gt;</span>;

<span class="kw">pub</span> <span class="kw">struct</span> <span class="ident">VirtualCore</span> {
    <span class="kw">pub</span> <span class="ident">tcbs</span>: <span class="ident">Vec</span><span class="op">&lt;</span><span class="ident">VirtualCoreTCB</span><span class="op">&gt;</span>,
}

<span class="kw">pub</span> <span class="kw">struct</span> <span class="ident">VirtualCoreTCB</span> {
    <span class="kw">pub</span> <span class="ident">cap</span>: <span class="ident">TCB</span>,
    <span class="kw">pub</span> <span class="ident">resume</span>: <span class="ident">bool</span>,
}

<span class="kw">pub</span> <span class="kw">struct</span> <span class="ident">PartialSubsystem</span> {
    <span class="kw">pub</span> <span class="ident">model</span>: <span class="ident">Model</span>,
    <span class="kw">pub</span> <span class="ident">model_view</span>: <span class="ident">ModelView</span>,
    <span class="kw">pub</span> <span class="ident">cregion</span>: <span class="ident">CRegion</span>,
    <span class="kw">pub</span> <span class="ident">cnode_untyped_id</span>: <span class="ident">UntypedId</span>,
    <span class="kw">pub</span> <span class="ident">local_object_slots</span>: <span class="ident">Vec</span><span class="op">&lt;</span><span class="ident">Slot</span><span class="op">&gt;</span>,
    <span class="kw">pub</span> <span class="ident">local_object_untyped_ids</span>: <span class="ident">Vec</span><span class="op">&lt;</span><span class="ident">UntypedId</span><span class="op">&gt;</span>,
}

<span class="kw">impl</span> <span class="ident">Realizer</span> {
    <span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">new</span>(
        <span class="ident">initialization_resources</span>: <span class="ident">SubsystemObjectInitializationResources</span>,
        <span class="ident">allocator</span>: <span class="ident">Allocator</span>,
        <span class="ident">externs</span>: <span class="ident">Externs</span>,
    ) <span class="op">-</span><span class="op">&gt;</span> <span class="self">Self</span> {
        <span class="ident">Realizer</span> {
            <span class="ident">initialization_resources</span>,
            <span class="ident">allocator</span>,
            <span class="ident">externs</span>,
        }
    }

    <span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">destroy</span>(<span class="kw-2">&amp;</span><span class="kw-2">mut</span> <span class="self">self</span>, <span class="ident">subsystem</span>: <span class="ident">Subsystem</span>) <span class="op">-</span><span class="op">&gt;</span> <span class="ident">Fallible</span><span class="op">&lt;</span>()<span class="op">&gt;</span> {
        <span class="self">self</span>.<span class="ident">allocator</span>
            .<span class="ident">revoke_and_free</span>(<span class="kw-2">&amp;</span><span class="ident">subsystem</span>.<span class="ident">cnode_untyped_id</span>)<span class="question-mark">?</span>;
        <span class="kw">for</span> <span class="ident">untyped_id</span> <span class="kw">in</span> <span class="kw-2">&amp;</span><span class="ident">subsystem</span>.<span class="ident">object_untyped_ids</span> {
            <span class="self">self</span>.<span class="ident">allocator</span>.<span class="ident">revoke_and_free</span>(<span class="kw-2">&amp;</span><span class="ident">untyped_id</span>)<span class="question-mark">?</span>;
        }
        <span class="self">self</span>.<span class="ident">externs</span>.<span class="ident">extend</span>(<span class="ident">subsystem</span>.<span class="ident">externs</span>);
        <span class="prelude-val">Ok</span>(())
    }

    <span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">realize_start</span>(<span class="kw-2">&amp;</span><span class="kw-2">mut</span> <span class="self">self</span>, <span class="ident">model</span>: <span class="ident">Model</span>) <span class="op">-</span><span class="op">&gt;</span> <span class="ident">Fallible</span><span class="op">&lt;</span><span class="ident">PartialSubsystem</span><span class="op">&gt;</span> {
        <span class="kw">let</span> <span class="ident">view</span> <span class="op">=</span> <span class="ident">ModelView::new</span>(<span class="kw-2">&amp;</span><span class="ident">model</span>);

        <span class="kw">let</span> <span class="ident">cnode_slots_size_bits</span> <span class="op">=</span> {
            <span class="kw">let</span> <span class="kw-2">mut</span> <span class="ident">num_frame_mappings</span>: <span class="ident">usize</span> <span class="op">=</span> <span class="number">0</span>;
            <span class="kw">for</span> <span class="ident">i</span> <span class="kw">in</span> <span class="ident">view</span>.<span class="ident">local_objects</span>.<span class="ident">iter</span>() {
                <span class="kw">if</span> <span class="kw">let</span> <span class="ident">AnyObj::Local</span>(<span class="ident">obj</span>) <span class="op">=</span> <span class="kw-2">&amp;</span><span class="ident">model</span>.<span class="ident">objects</span>[<span class="kw-2">*</span><span class="ident">i</span>].<span class="ident">object</span> {
                    <span class="kw">match</span> <span class="ident">obj</span> {
                        <span class="ident">Obj::PT</span>(<span class="ident">obj</span>) <span class="op">=</span><span class="op">&gt;</span> {
                            <span class="ident">num_frame_mappings</span> <span class="op">+</span><span class="op">=</span> <span class="ident">obj</span>.<span class="ident">entries</span>.<span class="ident">len</span>();
                        }
                        <span class="ident">Obj::PD</span>(<span class="ident">obj</span>) <span class="op">=</span><span class="op">&gt;</span> {
                            <span class="kw">for</span> <span class="ident">entry</span> <span class="kw">in</span> <span class="ident">obj</span>.<span class="ident">entries</span>.<span class="ident">values</span>() {
                                <span class="kw">if</span> <span class="kw">let</span> <span class="ident">PDEntry::LargePage</span>(<span class="kw">_</span>) <span class="op">=</span> <span class="ident">entry</span> {
                                    <span class="ident">num_frame_mappings</span> <span class="op">+</span><span class="op">=</span> <span class="number">1</span>;
                                }
                            }
                        }
                        <span class="kw">_</span> <span class="op">=</span><span class="op">&gt;</span> {}
                    }
                }
            }
            <span class="ident">size_bits_to_contain</span>(<span class="ident">view</span>.<span class="ident">local_objects</span>.<span class="ident">len</span>() <span class="op">+</span> <span class="ident">num_frame_mappings</span>)
        };

        <span class="kw">let</span> <span class="ident">local_object_blueprints</span>: <span class="ident">Vec</span><span class="op">&lt;</span><span class="ident">ObjectBlueprint</span><span class="op">&gt;</span> <span class="op">=</span> <span class="ident">view</span>
            .<span class="ident">local_objects</span>
            .<span class="ident">iter</span>()
            .<span class="ident">map</span>(<span class="op">|</span><span class="ident">i</span><span class="op">|</span> <span class="kw">match</span> <span class="kw-2">&amp;</span><span class="ident">model</span>.<span class="ident">objects</span>[<span class="kw-2">*</span><span class="ident">i</span>].<span class="ident">object</span> {
                <span class="ident">AnyObj::Local</span>(<span class="ident">obj</span>) <span class="op">=</span><span class="op">&gt;</span> <span class="ident">blueprint_of</span>(<span class="kw-2">&amp;</span><span class="ident">obj</span>),
                <span class="kw">_</span> <span class="op">=</span><span class="op">&gt;</span> <span class="macro">panic!</span>(),
            })
            .<span class="ident">collect</span>();

        <span class="kw">let</span> <span class="ident">untyped_requirements</span>: <span class="ident">Vec</span><span class="op">&lt;</span><span class="ident">usize</span><span class="op">&gt;</span> <span class="op">=</span> {
            <span class="kw">let</span> <span class="kw-2">mut</span> <span class="ident">v</span> <span class="op">=</span> <span class="macro">vec!</span>[<span class="number">0</span>; <span class="number">64</span>];
            <span class="ident">v</span>[<span class="ident">ObjectBlueprint::CNode</span> {
                <span class="ident">size_bits</span>: <span class="ident">cnode_slots_size_bits</span>,
            }
            .<span class="ident">physical_size_bits</span>()] <span class="op">+</span><span class="op">=</span> <span class="number">1</span>;
            <span class="kw">for</span> <span class="ident">blueprint</span> <span class="kw">in</span> <span class="kw-2">&amp;</span><span class="ident">local_object_blueprints</span> {
                <span class="ident">v</span>[<span class="ident">blueprint</span>.<span class="ident">physical_size_bits</span>()] <span class="op">+</span><span class="op">=</span> <span class="number">1</span>
            }
            <span class="ident">v</span>
        };
        <span class="macro">ensure!</span>(<span class="self">self</span>.<span class="ident">allocator</span>.<span class="ident">peek_space</span>(<span class="kw-2">&amp;</span><span class="ident">untyped_requirements</span>));

        <span class="kw">let</span> (<span class="kw-2">mut</span> <span class="ident">cregion</span>, <span class="ident">cnode_untyped_id</span>, <span class="ident">_managed_cnode_slot</span>) <span class="op">=</span>
            <span class="self">self</span>.<span class="ident">allocator</span>.<span class="ident">create_cnode</span>(<span class="ident">cnode_slots_size_bits</span>)<span class="question-mark">?</span>;
        <span class="kw">let</span> (<span class="ident">local_object_slots</span>, <span class="ident">local_object_untyped_ids</span>) <span class="op">=</span> <span class="self">self</span>
            .<span class="ident">allocator</span>
            .<span class="ident">create_objects</span>(<span class="kw-2">&amp;</span><span class="kw-2">mut</span> <span class="ident">cregion</span>, <span class="kw-2">&amp;</span><span class="ident">local_object_blueprints</span>)<span class="question-mark">?</span>;

        <span class="kw">let</span> <span class="ident">model_view</span> <span class="op">=</span> <span class="ident">ModelView::new</span>(<span class="kw-2">&amp;</span><span class="ident">model</span>);

        <span class="prelude-val">Ok</span>(<span class="ident">PartialSubsystem</span> {
            <span class="ident">model</span>,
            <span class="ident">model_view</span>,
            <span class="ident">cregion</span>,
            <span class="ident">cnode_untyped_id</span>,
            <span class="ident">local_object_slots</span>,
            <span class="ident">local_object_untyped_ids</span>,
        })
    }

    <span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">realize_continue</span>(
        <span class="kw-2">&amp;</span><span class="self">self</span>,
        <span class="ident">partial</span>: <span class="kw-2">&amp;</span><span class="ident">PartialSubsystem</span>,
        <span class="ident">obj_id</span>: <span class="ident">ObjId</span>,
        <span class="ident">fill_entry_index</span>: <span class="ident">usize</span>,
        <span class="ident">untrusted_content</span>: <span class="kw-2">&amp;</span>[<span class="ident">u8</span>],
    ) <span class="op">-</span><span class="op">&gt;</span> <span class="ident">Fallible</span><span class="op">&lt;</span>()<span class="op">&gt;</span> {
        <span class="kw">let</span> <span class="ident">obj</span> <span class="op">=</span> <span class="kw-2">&amp;</span><span class="ident">partial</span>.<span class="ident">model</span>.<span class="ident">objects</span>[<span class="ident">obj_id</span>];
        <span class="kw">if</span> <span class="kw">let</span> <span class="ident">AnyObj::Local</span>(<span class="ident">obj</span>) <span class="op">=</span> <span class="kw-2">&amp;</span><span class="ident">obj</span>.<span class="ident">object</span> {
            <span class="kw">let</span> <span class="ident">cptr_with_depth</span> <span class="op">=</span> <span class="ident">partial</span>
                .<span class="ident">cregion</span>
                .<span class="ident">cptr_with_depth</span>(<span class="ident">partial</span>.<span class="ident">local_object_slots</span>[<span class="ident">partial</span>.<span class="ident">model_view</span>.<span class="ident">reverse</span>[<span class="ident">obj_id</span>]]);
            <span class="kw">match</span> <span class="ident">obj</span> {
                <span class="ident">Obj::SmallPage</span>(<span class="ident">frame</span>) <span class="op">=</span><span class="op">&gt;</span> {
                    <span class="self">self</span>.<span class="ident">initialization_resources</span>.<span class="ident">fill_frame</span>(
                        <span class="ident">cptr_with_depth</span>.<span class="ident">local_cptr</span>::<span class="op">&lt;</span><span class="ident">SmallPage</span><span class="op">&gt;</span>(),
                        <span class="ident">frame</span>.<span class="ident">fill</span>[<span class="ident">fill_entry_index</span>].<span class="ident">offset</span>,
                        <span class="kw-2">&amp;</span><span class="ident">frame</span>.<span class="ident">fill</span>[<span class="ident">fill_entry_index</span>].<span class="ident">content_digest</span>,
                        <span class="ident">untrusted_content</span>,
                    )<span class="question-mark">?</span>;
                }
                <span class="ident">Obj::LargePage</span>(<span class="ident">frame</span>) <span class="op">=</span><span class="op">&gt;</span> {
                    <span class="self">self</span>.<span class="ident">initialization_resources</span>.<span class="ident">fill_frame</span>(
                        <span class="ident">cptr_with_depth</span>.<span class="ident">local_cptr</span>::<span class="op">&lt;</span><span class="ident">LargePage</span><span class="op">&gt;</span>(),
                        <span class="ident">frame</span>.<span class="ident">fill</span>[<span class="ident">fill_entry_index</span>].<span class="ident">offset</span>,
                        <span class="kw-2">&amp;</span><span class="ident">frame</span>.<span class="ident">fill</span>[<span class="ident">fill_entry_index</span>].<span class="ident">content_digest</span>,
                        <span class="ident">untrusted_content</span>,
                    )<span class="question-mark">?</span>;
                }
                <span class="kw">_</span> <span class="op">=</span><span class="op">&gt;</span> {
                    <span class="macro">panic!</span>()
                }
            }
        } <span class="kw">else</span> {
            <span class="macro">panic!</span>()
        }
        <span class="prelude-val">Ok</span>(())
    }

    <span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">realize_finish</span>(<span class="kw-2">&amp;</span><span class="kw-2">mut</span> <span class="self">self</span>, <span class="kw-2">mut</span> <span class="ident">partial</span>: <span class="ident">PartialSubsystem</span>) <span class="op">-</span><span class="op">&gt;</span> <span class="ident">Fallible</span><span class="op">&lt;</span><span class="ident">Subsystem</span><span class="op">&gt;</span> {
        <span class="kw">let</span> (<span class="ident">externs</span>, <span class="ident">extern_caps</span>): (<span class="ident">Externs</span>, <span class="ident">Vec</span><span class="op">&lt;</span><span class="ident">Unspecified</span><span class="op">&gt;</span>) <span class="op">=</span> {
            <span class="kw">let</span> <span class="kw-2">mut</span> <span class="ident">externs</span> <span class="op">=</span> <span class="ident">BTreeMap::new</span>();
            <span class="kw">let</span> <span class="ident">extern_caps</span>: <span class="ident">Vec</span><span class="op">&lt;</span><span class="ident">Unspecified</span><span class="op">&gt;</span> <span class="op">=</span> <span class="ident">partial</span>
                .<span class="ident">model_view</span>
                .<span class="ident">extern_objects</span>
                .<span class="ident">iter</span>()
                .<span class="ident">map</span>(<span class="op">|</span><span class="ident">i</span><span class="op">|</span> <span class="kw">match</span> <span class="kw-2">&amp;</span><span class="ident">partial</span>.<span class="ident">model</span>.<span class="ident">objects</span>[<span class="kw-2">*</span><span class="ident">i</span>].<span class="ident">object</span> {
                    <span class="ident">AnyObj::Extern</span>(<span class="ident">obj</span>) <span class="op">=</span><span class="op">&gt;</span> {
                        <span class="kw">let</span> <span class="ident">name</span> <span class="op">=</span> <span class="ident">partial</span>.<span class="ident">model</span>.<span class="ident">objects</span>[<span class="kw-2">*</span><span class="ident">i</span>].<span class="ident">name</span>.<span class="ident">clone</span>();
                        <span class="kw">let</span> <span class="ident">ext</span> <span class="op">=</span> <span class="self">self</span>.<span class="ident">externs</span>.<span class="ident">remove</span>(<span class="kw-2">&amp;</span><span class="ident">name</span>).<span class="ident">unwrap</span>();
                        <span class="macro">assert_eq!</span>(<span class="kw-2">&amp;</span><span class="ident">ext</span>.<span class="ident">ty</span>, <span class="ident">obj</span>);
                        <span class="kw">let</span> <span class="ident">cptr</span> <span class="op">=</span> <span class="ident">ext</span>.<span class="ident">cptr</span>;
                        <span class="ident">externs</span>.<span class="ident">insert</span>(<span class="ident">name</span>, <span class="ident">ext</span>);
                        <span class="ident">cptr</span>
                    }
                    <span class="kw">_</span> <span class="op">=</span><span class="op">&gt;</span> <span class="macro">panic!</span>(),
                })
                .<span class="ident">collect</span>();
            (<span class="ident">externs</span>, <span class="ident">extern_caps</span>)
        };

        <span class="kw">let</span> <span class="ident">all_caps</span>: <span class="ident">Vec</span><span class="op">&lt;</span><span class="ident">Unspecified</span><span class="op">&gt;</span> <span class="op">=</span> <span class="ident">partial</span>
            .<span class="ident">model</span>
            .<span class="ident">objects</span>
            .<span class="ident">iter</span>()
            .<span class="ident">enumerate</span>()
            .<span class="ident">map</span>(<span class="op">|</span>(<span class="ident">i</span>, <span class="ident">obj</span>)<span class="op">|</span> <span class="kw">match</span> <span class="kw-2">&amp;</span><span class="ident">obj</span>.<span class="ident">object</span> {
                <span class="ident">AnyObj::Local</span>(<span class="kw">_</span>) <span class="op">=</span><span class="op">&gt;</span> <span class="ident">partial</span>
                    .<span class="ident">cregion</span>
                    .<span class="ident">cptr_with_depth</span>(<span class="ident">partial</span>.<span class="ident">local_object_slots</span>[<span class="ident">partial</span>.<span class="ident">model_view</span>.<span class="ident">reverse</span>[<span class="ident">i</span>]])
                    .<span class="ident">local_cptr</span>::<span class="op">&lt;</span><span class="ident">Unspecified</span><span class="op">&gt;</span>(),
                <span class="ident">AnyObj::Extern</span>(<span class="kw">_</span>) <span class="op">=</span><span class="op">&gt;</span> <span class="ident">extern_caps</span>[<span class="ident">partial</span>.<span class="ident">model_view</span>.<span class="ident">reverse</span>[<span class="ident">i</span>]],
            })
            .<span class="ident">collect</span>();

        <span class="kw">let</span> <span class="ident">virtual_cores</span> <span class="op">=</span> <span class="self">self</span>.<span class="ident">initialization_resources</span>.<span class="ident">initialize</span>(
            <span class="ident">partial</span>.<span class="ident">model</span>.<span class="ident">num_nodes</span>,
            <span class="kw-2">&amp;</span><span class="ident">partial</span>.<span class="ident">model</span>,
            <span class="kw-2">&amp;</span><span class="ident">all_caps</span>,
            <span class="kw-2">&amp;</span><span class="kw-2">mut</span> <span class="ident">partial</span>.<span class="ident">cregion</span>,
        )<span class="question-mark">?</span>;

        <span class="prelude-val">Ok</span>(<span class="ident">Subsystem</span> {
            <span class="ident">virtual_cores</span>,
            <span class="ident">cnode_untyped_id</span>: <span class="ident">partial</span>.<span class="ident">cnode_untyped_id</span>,
            <span class="ident">object_untyped_ids</span>: <span class="ident">partial</span>.<span class="ident">local_object_untyped_ids</span>,
            <span class="ident">externs</span>,
        })
    }
}
</code></pre></div>
</section><section id="search" class="content hidden"></section><div id="rustdoc-vars" data-root-path="../../" data-current-crate="dyndl_realize" data-search-index-js="../../search-index.js" data-search-js="../../search.js"></div>
    <script src="../../main.js"></script><script src="../../source-script.js"></script><script src="../../source-files.js"></script>
</body></html>